codeforces 913C Party Lemonade

81 篇文章 0 订阅
49 篇文章 0 订阅

http://www.elijahqi.win/2018/01/09/codeforces-913c-party-lemonade/

C. Party Lemonade
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

A New Year party is not a New Year party without lemonade! As usual, you are expecting a lot of guests, and buying lemonade has already become a pleasant necessity.

Your favorite store sells lemonade in bottles of n different volumes at different costs. A single bottle of type i has volume 2i - 1 liters and costs ci roubles. The number of bottles of each type in the store can be considered infinite.

You want to buy at least L liters of lemonade. How many roubles do you have to spend?
Input

The first line contains two integers n and L (1 ≤ n ≤ 30; 1 ≤ L ≤ 109) — the number of types of bottles in the store and the required amount of lemonade in liters, respectively.

The second line contains n integers c1, c2, …, cn (1 ≤ ci ≤ 109) — the costs of bottles of different types.
Output

Output a single integer — the smallest number of roubles you have to pay in order to buy at least L liters of lemonade.
Examples
Input

4 12
20 30 70 90

Output

150

Input

4 3
10000 1000 100 10

Output

10

Input

4 3
10 100 1000 10000

Output

30

Input

5 787787787
123456789 234567890 345678901 456789012 987654321

Output

44981600785557577

Note

In the first example you should buy one 8-liter bottle for 90 roubles and two 2-liter bottles for 30 roubles each. In total you’ll get 12 liters of lemonade for just 150 roubles.

In the second example, even though you need only 3 liters, it’s cheaper to buy a single 8-liter bottle for 10 roubles.

In the third example it’s best to buy three 1-liter bottles for 10 roubles each, getting three liters for 30 roubles.

还是icefox巨佬强啊orz %%我好菜啊 细节太多我还是fail system test了

题意:给定2^0~2^n-1L的汽水 的花费 最后至少L的汽水的最小花费是多少

那么首先我们把他给的数都读进来 然后倒着dp一下 设dp[i]表示买2^i的最小花费是多少

然后得到每个正确的花费 然后针对每一位贪心考虑即可 为什么这题可以贪心考虑 因为这个都是2的次幂 所以我 确信我如果小的次幂多选了 一定不会影响我大的次幂

所以可以这么来搞 我把L转换成二进制 单独考虑每一个二进制位上的数怎么去搞

假设我这个二进制是1010110001 那么 首先有1的位置我可以认为一定买2^i最优 比如处理其中一个子问题110001的时候 在处理最高位1的时候 我有可能选两个这个一位置上的数 有可能就是按部就班的选一个 然后比我最高位小的地方我再递归下去去搞 这里得注意一些细节 就是比如我选了最后一个1010110001的最后一个1 但是我发现 它到上一个1的位置中的某个0的位置我选了反而会更好 那么我就需要去选一下这个位置的0 然后后面原本算出来的代价直接被替换就好

还有个小细节 我这样算出来 比如8的费用是1000 但是我发现我买1000的费用只需要10即可 我最后还需要扫一遍 把这种情况做掉即可

#include<cmath>
#include<cstdio>
#include<algorithm>
#define ll long long
using namespace std;
int n,L;long long cost[33];
inline ll dfs(int v){
    double len=log2(v);int len1=len;
    if(len==len1) return cost[len1];
    ll left=v-(1<<len1);ll tmp=dfs(left);int len2=log2(left);
    for (int i=len2+1;i<=len1;++i) tmp=min(tmp,cost[i]);
    return cost[len1]*2<cost[len1]+tmp?cost[len1]*2:cost[len1]+tmp;
}
int main(){
    freopen("cf.in","r",stdin);
    scanf("%d%d",&n,&L);
    for (int i=1;i<=32;++i) cost[i]=1LL<<62; 
    for (int i=0;i<n;++i) scanf("%lld",&cost[i]);
    for (int i=1;i<=32;++i) cost[i]=min(cost[i],cost[i-1]*2);
    //for (int i=0;i<30;++i) printf("%lld ",cost[i]);puts("");
    int len=log2(L);ll ans=dfs(L);
    for (int i=len+1;i<=32;++i) ans=min(ans,cost[i]);
    printf("%I64d",ans);
    return 0;
}
  • 2
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值